<?php

namespace Eniture\ResidentialAddressDetection\Controller\RAD;

use \Magento\Framework\App\Action\Action;

class AutoRenewPlan extends Action
{
    /**
     *  read instance
     * @var object
     */
    private $changePlanReqUrl = 'https://eniture.com/ws/addon/smartStreetApi/index.php';

    private $dataHelper;
    private $request;

    /**
     * AutoRenewPlan constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Eniture\ResidentialAddressDetection\Helper\Data $dataHelper
     * @param \Magento\Framework\App\RequestInterface $httpRequest
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Eniture\ResidentialAddressDetection\Helper\Data $dataHelper,
        \Magento\Framework\App\RequestInterface $httpRequest
    ) {
        $this->dataHelper        = $dataHelper;
        $this->request = $httpRequest;
        parent::__construct($context);
    }

    /**
     * Auto renew plan
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        
        $planAction = isset($postdata['planAction'])?$postdata['planAction']:'';
        $package    = isset($postdata['package'])?$postdata['package']:'';
        $licenseKey = isset($postdata['licenseKey'])?$postdata['licenseKey']:'';
        
        $postArr = array(
            'platform'      => 'magento2',
            'version'       => '2.0',
            'requestKey'    => md5(microtime() . rand()),
            'action'        => $planAction,
            'package'       => $package,
           'serverName'     => $this->request->getServer('SERVER_NAME'),
            'licenseKey'    => $licenseKey,
        );

        $newPlan = $this->dataHelper->sendRequest($this->changePlanReqUrl,$postArr);
        
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($newPlan));           
    }
}
