<?php

namespace Eniture\ResidentialAddressDetection\Controller\RAD;

use \Magento\Framework\App\Action\Action;

class SuspendedRAD extends Action
{

    private $resourceConfig;
    private $helperData;

    /**
     * SuspendedRAD constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\App\Config\ConfigResource\ConfigInterface $resourceConfig
     * @param \Eniture\ResidentialAddressDetection\Helper\Data $helperData
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\App\Config\ConfigResource\ConfigInterface  $resourceConfig,
        \Eniture\ResidentialAddressDetection\Helper\Data  $helperData
    ) {
        $this->resourceConfig       = $resourceConfig;
        $this->helperData       = $helperData;
        parent::__construct($context);
    }
    
    /**
     * Suspend Auto Detect Residential Feature
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        $suspend = $postdata['suspend'];
        $this->saveConfigurations('resaddressdetection/suspend/value', $suspend);

        $this->helperData->cacheClean();
        
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode(array('suspend' => $suspend)));           
    }
    
    /**
     * 
     * @param type $path
     * @param type $value
     */
    function saveConfigurations($path, $value) {
        $this->resourceConfig->saveConfig(
            $path, 
            $value, 
            \Magento\Framework\App\Config\ScopeConfigInterface::SCOPE_TYPE_DEFAULT, 
            \Magento\Store\Model\Store::DEFAULT_STORE_ID
        );
    }
}
