<?php
/**
 * @category   Shipping
 * @package    Eniture_ResidentialAddressDetection
 * @author     Eniture Technology : <sales@eniture.com>
 * @website    http://eniture.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
/**
 * Eniture Box Sizes Installation Script Class
 */
namespace Eniture\ResidentialAddressDetection\Setup;
 
use Magento\Framework\Setup\InstallDataInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;

/**
 * @codeCoverageIgnore
 */
class InstallData implements InstallDataInterface
{
    /**
     * @var \Magento\Framework\App\Config\ConfigResource\ConfigInterface
     */
    private $resourceConfig;
    /**
     * @var \Eniture\ResidentialAddressDetection\App\State
     */
    private $state;
    /**
     * InstallData constructor.
     * @param \Eniture\ResidentialAddressDetection\App\State $state
     * @param \Magento\Framework\App\Config\ConfigResource\ConfigInterface $resourceConfig
     */
    function __construct(
        \Eniture\ResidentialAddressDetection\App\State $state,
        \Magento\Framework\App\Config\ConfigResource\ConfigInterface $resourceConfig
    ) {
        $this->resourceConfig = $resourceConfig;
        $this->state = $state;
    }

    /**
     * @param ModuleDataSetupInterface $setup
     * @param ModuleContextInterface $context
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function install(ModuleDataSetupInterface $setup, ModuleContextInterface $context)
    {
        if (!$this->state->validateAreaCode()) {
            $this->state->setAreaCode(\Magento\Framework\App\Area::AREA_GLOBAL);
        }
        
        $installer = $setup;
        $installer->startSetup();
        $this->saveConfigurations('enitureRAD/trial/use', '0');
        $this->saveConfigurations('resaddressdetection/suspend/value', 'no');
        $installer->endSetup();
    }
    
    /**
     * 
     * @param type $path
     * @param type $value
     */
    function saveConfigurations($path, $value) {
        $this->resourceConfig->saveConfig(
            $path, 
            $value, 
            \Magento\Framework\App\Config\ScopeConfigInterface::SCOPE_TYPE_DEFAULT, 
            \Magento\Store\Model\Store::DEFAULT_STORE_ID
        );
    }
}