    /**
     * Document load function
     * @type type
     */
    var isdisabled = false;
    require([ 'jquery', 'jquery/ui'], function($){ 
        $(document).ready(function($) {
            // disablealwaysresidential();
            
            $('#rad-plan-upgrade').on('focus', function(){
                $(this).attr('oldValue',$(this).val());
            });
            
            $(".res-cancel-plan").on('click', function (){
                $('#rad-plan-upgrade').prop('selectedIndex', 'disable');
            });
            
            disablesuspendbox();
        });
    });

    /**
     * @return {bool}
     */
    var disablesuspendbox = function(){
        if (jQuery('.disable-plan').length) {
            jQuery("#suspend-rad-use").prop({disabled: true});
            isdisabled = true;
        }else{
            isdisabled = false;
        }
    };
    
    /**
     * @param {type} ajaxUrl
     * @param {type} licenseKey
     * @return {Boolean}
     */
    function autoRenewRADPlan(ajaxUrl, licenseKey){
        var oldVal  = jQuery("#rad-plan-upgrade").attr('oldvalue');
        var package = jQuery( "#rad-plan-upgrade" ).val();
        var action  = (package == 'disable') ? 'd' : 'c';

        if(oldVal == 'disable'){
             var selected_plan = jQuery("#rad-plan-upgrade").find("option:selected").text();
            jQuery("#selectedPlanPopupBox").text(selected_plan);
            
            window.location.href = jQuery('.plan-change-notification').attr('href');
            jQuery('.res-confirm-plan').on('click', function(){
                window.location.href = jQuery('.res-confirm-plan').attr('href');
                return autoRenewResPlan(package, action, licenseKey, ajaxUrl);
            });
        }else{
            return autoRenewResPlan(package, action, licenseKey, ajaxUrl);
        }
    } 
    
    /**
     * @param {type} package
     * @param {type} action
     * @param {type} licenseKey
     * @param {type} ajaxUrl
     * @return {Boolean}
     */
    function autoRenewResPlan(package, action, licenseKey, ajaxUrl){
        var parameters = {
                'action'     : 'changeRADPlan',
                'package'    : package,
                'planAction' : action,
                'licenseKey' : licenseKey,
            };

        ajaxRequest(parameters, ajaxUrl, ResPlanResSettings);
        return false;
    }
    
    /**
     * @param {type} data
     * @return {undefined}
     */
    function ResPlanResSettings(data){
        if(data.severity == 'ERROR'){
            showPlanResponseMsgsRAD('.res-plan-change-err', '.error-msg', data.Message);
        }
        if(data.severity == 'SUCCESS'){
            showPlanResponseMsgsRAD('.res-plan-change-success', '.success-msg', data.Message);
        }
    }
    
    /**
     * @param {type} divClass
     * @param {type} message
     * @return {undefined}
     */
    function showPlanResponseMsgsRAD(divClass, textClass, message){
        jQuery(textClass).text(message);
        jQuery(divClass).show('slow');
        setTimeout(function () {
            jQuery(divClass).hide('slow');
        }, 5000);

        jQuery('html, body').animate({ 'scrollTop' : jQuery(divClass).offset().top-100 });
    }

    /**
     * @param {type} ajaxUrl
     * @return {Boolean}
     */
    function suspendAutoRes(ajaxUrl){
            var suspend = jQuery('#suspend-rad-use').is(':checked');
            var parameters = {
                   'action'  : 'suspend-use',
                   'suspend' : (suspend == true)?'yes':'no'
               };
               
               ajaxRequest(parameters, ajaxUrl, suspendAutoResSettings);
                
            return false;
    }

    function suspendAutoResSettings(data) {
        if(data.suspend == 'no'){
            jQuery('#suspend-rad-use').prop("checked", false);
        } else {
            jQuery('#suspend-rad-use').prop("checked", true);
        }
    }
    
    /**
     * @param {type} parameters
     * @param {type} ajaxUrl
     * @param {type} responseFunction
     * @return {undefined}
     */
    function ajaxRequest(parameters, ajaxUrl, responseFunction){

        new Ajax.Request(ajaxUrl, {
            method:  'POST',
            parameters: parameters,
            onSuccess: function(response){

                if (response.responseText){
                    var json = response.responseText;
                    var data = JSON.parse(json);
                    var callbackRes = responseFunction(data);
                    return callbackRes;
                }
            }
        });
    }
